# proj209:custom-filesystem

## linux custom filesystem
自己设计一个Linux 文件系统并实现文件和目录读写操作

### 【项目描述】
1、设计实现一个Linux内核模块，此模块完成如下功能：
  - 将新创建的文件系统的操作接口和VFS对接。
  - 实现新的文件系统的超级块、dentry、inode的读写操作。
  - 实现新的文件系统的权限属性，不同的用户不同的操作属性。
  - 实现和用户态程序的对接，用户程序

2、设计实现一个用户态应用程序，可以将一个块设备（可以用文件模拟）格式化成自己设计的文件系统的格式。

3、设计一个用户态的测试用例应用程序，测试验证自己的文件系统的open/read/write/ls/cd 等通常文件系统的访问。

### 【所属赛道】
2022全国大学生操作系统比赛的“OS功能设计”赛道

### 【参赛要求】
- 以小组为单位参赛，最多三人一个小组，且小组成员是来自同一所高校的本科生或研究生
- 如学生参加了多个项目，参赛学生选择一个自己参加的项目参与评奖
- 请遵循“2022全国大学生操作系统比赛”的章程和技术方案要求

### 【项目导师】
刘冬华
- github https://github.com/cliff-china
- email donghua.liu@ucas.com.cn

### 【难度】
中等

### 【License】
MIT license (LICENSE-MIT or http://opensource.org/licenses/MIT)  

## 【预期目标】
- 完成Linux内核部分文件系统的设计改造
- 系统能平稳运行

### 【参考资源】
- C++语言相关书籍