# 伪文件系统格式化

## types

拟设计一个文件模拟块设备的伪文件系统，对于一般文件系统，将块设备的格式化可视为在其上挂载，建立完整的系统结构。对于此文件系统，可进一步简化为对地址的分配。


```
struct filesystem_type {
    const char* name;
    int(*get_fs)(struct filesystem_type *, int, const char *, void *);
}
```



维护双向链表
``` 
struct list_head {
    struct list_head *next, *prev; 
}
```

原子计数
```
typedef struct {
    volatile int counter;
} atomic_t
```

```
init counter = 1
read 
set
```

```
struct kref{
    atomic_t refcount;
}
```